/**
 * (C) 2011-2012 Alibaba Group Holding Limited.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 */
/**
 * Copyright 2007 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.taobao.common.tedis.support.lucene.analysis.xanalyzer;

import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;

import org.apache.lucene.analysis.Token;

public class Main1 {

    public static void main(String[] args) throws IOException {
        long b0 = System.currentTimeMillis();
        XAnalyzer analyzer = XFactory.getWriterAnalyzer();// ʱӦʹõķ
        // ״νʱװشʵ
        afterLoadingDictionary(analyzer);
        System.out.println("Dictionary loaded successfully.");

        // ¼װشʵʱ
        long b1 = System.currentTimeMillis();// (b1 - b0)Ϊװشʵʱ

        // testStringСǣ17077 33965ֽ
        String testString = "18꣬иԳҵ˵㽫ע˾塣˵ôܣҲƯҲ̰ҲҪ̫࣬һֻ밮һΣֻҪһҵɷȻĺӡΪϴ´ӡҪ鵽ϡ ˵пֵͯ꣬˵ʲôδÿһ춼ڱ䣬ûгõĿѣȻҲûгõҸ⻰ʱҸоԼﵽ⿪ʼ䡣ô꣬һֱͼһԤԣȴͽ޹ܶˣҲҰңоǱ˴మȴΪԵ޷ݶòֿǶ˵ǺùȻһ23ʱҾ˵һʧܡҵĳӽǷֵʱҲĴ졣һؼǵãڽߵĲ԰ǶҿԷ۾ҵ۾ĴѲҿѿˣƵҶ¿ֵط賤кܶƯӵڽǡҶһֱվˮУϺõ̲衣ʶӽһǸĻǲǾһоͿѵĿʼأҺܺ¡ӽһڵСжѧϤҵļһϤСҪõѵС˵̨DJһҹֽĿӴˣ罻 Ҿ޶޸ĳƼһеĴƮһҰμҡеϱ߰ᵽߣٴӱ߰ᵽȻ󶫱ߡҺ޼Ưûоͷûϣӡÿʮϰ࣬ʮ°ࡣһԽеҹһܾµױƯ·峿ʱһȥưһʱ°ͻؼһ̨ԣȴѾ㹻ҹ˾ʱεÿ׼ʱ賿һȻڸBBS֮εддͣͣߡҺϸӣۻһȦʱڽĿ٩٩̸ʵ˼ȴ׾ڱǲ֪ĴǡرԼ뷨ʶ˲࣬һҰ˵ǹ»Ұֻҹûʱҽڤ˵ŮӲӦȡǵ֣ЦͣΪҲֻҹǴӲʶԷǸʲôģֻϲض˵˵ҵ˵ϲԼԼеҹĴɢ˵ھİҲ·˵ϣһӣ泯󺣣ůǰ˵ô˼άҡԴǵߵҲӲǷѡϲ໥ΣʹϡҽҰӲڤѾͷǵĳƺҵģֻҹһӲĮˣӲڰǸҰ˴ӲΪʲôֻǶ˵ҲһȱŮӣۡҶҰ˵ֻΪһŴ洢ҵĵصԺһ̴ҵҰԺʧһССĲҲӴ˲ٳ֡ӳ껪˵ҵġĬʾԡ˵ûиģС ϴѧʱʦνԼõĶ˺࿴һֱǵҾ仰Ŭһϲ磬ȴСİϲ˺ˣ˱硣 ˵ҰԼ߰㣬иչң˵ٲ޾ûҪˣǿҰһ˵ðҽܸ˰ɣҪڠػԸҡʵʱҲ26꣬30˵ǻ껪 һμ·1812ưɣҺ͵һžͿڰ̨ĽģһںƾơΪ˽ܣǵһμ棬ʵǶڶԷ̾ᡣкܶΣֹ ֹǽǸˣһСһ𡣵˵ЩҲںЩమˡ һθеһϬĬҸ룬һһӰҲҪҲһҰȻҿʼСؾӪݰ顣ϲ̨ĹĻһݳĹÿؼҡҽǸҰˡϣҵİԸƽ˿ڡһԭǺúõġҲ˵ĻһжᷢͽһʱˡҲҪһνŵ֣Ҵûమ˵ˣû˰ҪʲôֻΪӣһļҡ ˵뷨Ժ󣬽ľʧˡȥϰĵطܶҸҵ绰˵ҴˣҲҪȢңֻҪһڵ绰Ĭ벻׿Ϊʲô»ÿ˼㱣ϻؼǺ˼룬Ѹٵȥҵ1812ȥȾƣҺͿĵһμĵطԻڶߣһȴѾı䡣Һ˺ܶơҿһͷǹھƹˤһͷ­ҽ֪ΪʲôΪʲôһͷһ֪ͷǰŮǷҲй˵İ顣˵ϰӻҽԺͷǣǰһǳƯŮֻϴ20ꡣʥڵʱ򣬿̫裬ˤˣýճ˵һˣǰӳġ˵Ҳϲأҹҹϸð˵ôסһҪ˵Ůǰûй̹ĵİһһغȾơʱͿһҵǰĳסңͣ˵ԲԲȵҵϺҵһָе¶ȣůҿ˵ҲûҿԲҪҪ֣ʲôҪֻҪ뿪ҡ˵ĿԡǰڲӵʱˤϹ׵Ȼںˣʱпܵ÷̱ҪΪܿࡣ˵ҶҪһƶٰˡ˵ɵѾͷôܲأûһŻʲô˼ ʧõİҾöĿʵ㲻ʲôҸһңֻҪҲĶҺܺãƺҲй۵İϧΪӿԾһֱȥ˵ѾҪҪҺͿһ𡣶ңǱ˴మ ֪ǲҿЦһº󣬿ʧˡһһʲôԣȻͻȻʧ١ҵڼԲȵĵ绰ܾԺҿҪȥʱ򣬿Ĵشص绰˵ܸһңûԼķȢҡ 㾡һ׷ӡ˵ԼķˣˣȴԸٻߡ˺ܶ࣬ЩҲ˼ңȻôݡҺȻҸģһһ꣬һֱΪ˽Է˽Լһһֱ˰һжҪˡ˿̣Ҳŷȫ֪ʲôҪʲôҸеÿһεеĴСҸˣˡ·ϵʱһüսײкüΣһ㱿ڸңһҿˡ ͬ½飬ȥףڽ﷭ǵĻɴգﱯޱȡи߹˵ףôĲҿ¥Ѿվ˰СʱˣܽӡһΪڵءҸ˲֪ҺͿ֮Щ¡վ¥³壬ֻ¥һص̵١ȷſȻǰҵģֻҪ۷ʲôҶԭι£Ѿûгλİˡǰҵģӹɡڶ뿪ҵԭţ١ĳˡһֱʹȴұŮҲӡŮˣʮŮ˷ȻһֱԴڽϿĵһ۾϶ʹ˿̵찲ŵԵ֣ǣ뿪ңʼ׷һƺߵġ˵һŮƭҡһȥҲۣ벻ԲŸҡⷬʱҾԼǻȻΪôһݡΪûһɱҲôΪһԼ˶ĥԼ֪뿪ҵԭһ˿һѹģҲΪԼ۶ġǣֻص̨ȻûԲǸഺٵΣ˵Ļңû޷ȻʧЦ˵Ҳ˵Ļ˵޴ĻѲˣҲʹ˭û˭ûʲô˵ġҽ˿ĵĵһλЩ£Ĵû˵ҲӲǰڲӣƶǳͷءôŬӪҲһֱûдΪ˸ıˣȢ˲ϲųŮλûдתİڼŭǣˡƺ׷ֻһమ˺úӪͶһ൱ˣΪѾˣԲǡ˵ԲңʶЦЦ˵һжȥˡοԹ˭עġ18ʱע˵ġѡ񰮾ѡѡ һ˳СDJĹ ˵ҵ͸ž͸ľ ˵ԽԽ˵ǣһҹŮô ڱʼָָ㣬˵һ30Ů˻һ⡣ ҲΪ ֪һ죬һȥû˻˵ 18꣬иԳҵ˵㽫ע˾塣˵ôܣҲƯҲ̰ҲҪ̫࣬һֻ밮һΣֻҪһҵɷȻĺӡΪϴ´ӡҪ鵽ϡ ˵пֵͯ꣬˵ʲôδÿһ춼ڱ䣬ûгõĿѣȻҲûгõҸ⻰ʱҸоԼﵽ⿪ʼ䡣ô꣬һֱͼһԤԣȴͽ޹ܶˣҲҰңоǱ˴మȴΪԵ޷ݶòֿǶ˵ǺùȻһ23ʱҾ˵һʧܡҵĳӽǷֵʱҲĴ졣һؼǵãڽߵĲ԰ǶҿԷ۾ҵ۾ĴѲҿѿˣƵҶ¿ֵط賤кܶƯӵڽǡҶһֱվˮУϺõ̲衣ʶӽһǸĻǲǾһоͿѵĿʼأҺܺ¡ӽһڵСжѧϤҵļһϤСҪõѵС˵̨DJһҹֽĿӴˣ罻 Ҿ޶޸ĳƼһеĴƮһҰμҡеϱ߰ᵽߣٴӱ߰ᵽȻ󶫱ߡҺ޼Ưûоͷûϣӡÿʮϰ࣬ʮ°ࡣһԽеҹһܾµױƯ·峿ʱһȥưһʱ°ͻؼһ̨ԣȴѾ㹻ҹ˾ʱεÿ׼ʱ賿һȻڸBBS֮εддͣͣߡҺϸӣۻһȦʱڽĿ٩٩̸ʵ˼ȴ׾ڱǲ֪ĴǡرԼ뷨ʶ˲࣬һҰ˵ǹ»Ұֻҹûʱҽڤ˵ŮӲӦȡǵ֣ЦͣΪҲֻҹǴӲʶԷǸʲôģֻϲض˵˵ҵ˵ϲԼԼеҹĴɢ˵ھİҲ·˵ϣһӣ泯󺣣ůǰ˵ô˼άҡԴǵߵҲӲǷѡϲ໥ΣʹϡҽҰӲڤѾͷǵĳƺҵģֻҹһӲĮˣӲڰǸҰ˴ӲΪʲôֻǶ˵ҲһȱŮӣۡҶҰ˵ֻΪһŴ洢ҵĵصԺһ̴ҵҰԺʧһССĲҲӴ˲ٳ֡ӳ껪˵ҵġĬʾԡ˵ûиģС ϴѧʱʦνԼõĶ˺࿴һֱǵҾ仰Ŭһϲ磬ȴСİϲ˺ˣ˱硣 ˵ҰԼ߰㣬иչң˵ٲ޾ûҪˣǿҰһ˵ðҽܸ˰ɣҪڠػԸҡʵʱҲ26꣬30˵ǻ껪 һμ·1812ưɣҺ͵һžͿڰ̨ĽģһںƾơΪ˽ܣǵһμ棬ʵǶڶԷ̾ᡣкܶΣֹ ֹǽǸˣһСһ𡣵˵ЩҲںЩమˡ һθеһϬĬҸ룬һһӰҲҪҲһҰȻҿʼСؾӪݰ顣ϲ̨ĹĻһݳĹÿؼҡҽǸҰˡϣҵİԸƽ˿ڡһԭǺúõġҲ˵ĻһжᷢͽһʱˡҲҪһνŵ֣Ҵûమ˵ˣû˰ҪʲôֻΪӣһļҡ ˵뷨Ժ󣬽ľʧˡȥϰĵطܶҸҵ绰˵ҴˣҲҪȢңֻҪһڵ绰Ĭ벻׿Ϊʲô»ÿ˼㱣ϻؼǺ˼룬Ѹٵȥҵ1812ȥȾƣҺͿĵһμĵطԻڶߣһȴѾı䡣Һ˺ܶơҿһͷǹھƹˤһͷ­ҽ֪ΪʲôΪʲôһͷһ֪ͷǰŮǷҲй˵İ顣˵ϰӻҽԺͷǣǰһǳƯŮֻϴ20ꡣʥڵʱ򣬿̫裬ˤˣýճ˵һˣǰӳġ˵Ҳϲأҹҹϸð˵ôסһҪ˵Ůǰûй̹ĵİһһغȾơʱͿһҵǰĳסңͣ˵ԲԲȵҵϺҵһָе¶ȣůҿ˵ҲûҿԲҪҪ֣ʲôҪֻҪ뿪ҡ˵ĿԡǰڲӵʱˤϹ׵Ȼںˣʱпܵ÷̱ҪΪܿࡣ˵ҶҪһƶٰˡ˵ɵѾͷôܲأûһŻʲô˼ ʧõİҾöĿʵ㲻ʲôҸһңֻҪҲĶҺܺãƺҲй۵İϧΪӿԾһֱȥ˵ѾҪҪҺͿһ𡣶ңǱ˴మ ֪ǲҿЦһº󣬿ʧˡһһʲôԣȻͻȻʧ١ҵڼԲȵĵ绰ܾԺҿҪȥʱ򣬿Ĵشص绰˵ܸһңûԼķȢҡ 㾡һ׷ӡ˵ԼķˣˣȴԸٻߡ˺ܶ࣬ЩҲ˼ңȻôݡҺȻҸģһһ꣬һֱΪ˽Է˽Լһһֱ˰һжҪˡ˿̣Ҳŷȫ֪ʲôҪʲôҸеÿһεеĴСҸˣˡ·ϵʱһüսײкüΣһ㱿ڸңһҿˡ ͬ½飬ȥףڽ﷭ǵĻɴգﱯޱȡи߹˵ףôĲҿ¥Ѿվ˰СʱˣܽӡһΪڵءҸ˲֪ҺͿ֮Щ¡վ¥³壬ֻ¥һص̵١ȷſȻǰҵģֻҪ۷ʲôҶԭι£Ѿûгλİˡǰҵģӹɡڶ뿪ҵԭţ١ĳˡһֱʹȴұŮҲӡŮˣʮŮ˷ȻһֱԴڽϿĵһ۾϶ʹ˿̵찲ŵԵ֣ǣ뿪ңʼ׷һƺߵġ˵һŮƭҡһȥҲۣ벻ԲŸҡⷬʱҾԼǻȻΪôһݡΪûһɱҲôΪһԼ˶ĥԼ֪뿪ҵԭһ˿һѹģҲΪԼ۶ġǣֻص̨ȻûԲǸഺٵΣ˵Ļңû޷ȻʧЦ˵Ҳ˵Ļ˵޴ĻѲˣҲʹ˭û˭ûʲô˵ġҽ˿ĵĵһλЩ£Ĵû˵ҲӲǰڲӣƶǳͷءôŬӪҲһֱûдΪ˸ıˣȢ˲ϲųŮλûдתİڼŭǣˡƺ׷ֻһమ˺úӪͶһ൱ˣΪѾˣԲǡ˵ԲңʶЦЦ˵һжȥˡοԹ˭עġ18ʱע˵ġѡ񰮾ѡѡ һ˳СDJĹ ˵ҵ͸ž͸ľ ˵ԽԽ˵ǣһҹŮô ڱʼָָ㣬˵һ30Ů˻һ⡣ ҲΪ ֪һ죬һȥû˻˵18꣬иԳҵ˵㽫ע˾塣˵ôܣҲƯҲ̰ҲҪ̫࣬һֻ밮һΣֻҪһҵɷȻĺӡΪϴ´ӡҪ鵽ϡ ˵пֵͯ꣬˵ʲôδÿһ춼ڱ䣬ûгõĿѣȻҲûгõҸ⻰ʱҸоԼﵽ⿪ʼ䡣ô꣬һֱͼһԤԣȴͽ޹ܶˣҲҰңоǱ˴మȴΪԵ޷ݶòֿǶ˵ǺùȻһ23ʱҾ˵һʧܡҵĳӽǷֵʱҲĴ졣һؼǵãڽߵĲ԰ǶҿԷ۾ҵ۾ĴѲҿѿˣƵҶ¿ֵط賤кܶƯӵڽǡҶһֱվˮУϺõ̲衣ʶӽһǸĻǲǾһоͿѵĿʼأҺܺ¡ӽһڵСжѧϤҵļһϤСҪõѵС˵̨DJһҹֽĿӴˣ罻 Ҿ޶޸ĳƼһеĴƮһҰμҡеϱ߰ᵽߣٴӱ߰ᵽȻ󶫱ߡҺ޼Ưûоͷûϣӡÿʮϰ࣬ʮ°ࡣһԽеҹһܾµױƯ·峿ʱһȥưһʱ°ͻؼһ̨ԣȴѾ㹻ҹ˾ʱεÿ׼ʱ賿һȻڸBBS֮εддͣͣߡҺϸӣۻһȦʱڽĿ٩٩̸ʵ˼ȴ׾ڱǲ֪ĴǡرԼ뷨ʶ˲࣬һҰ˵ǹ»Ұֻҹûʱҽڤ˵ŮӲӦȡǵ֣ЦͣΪҲֻҹǴӲʶԷǸʲôģֻϲض˵˵ҵ˵ϲԼԼеҹĴɢ˵ھİҲ·˵ϣһӣ泯󺣣ůǰ˵ô˼άҡԴǵߵҲӲǷѡϲ໥ΣʹϡҽҰӲڤѾͷǵĳƺҵģֻҹһӲĮˣӲڰǸҰ˴ӲΪʲôֻǶ˵ҲһȱŮӣۡҶҰ˵ֻΪһŴ洢ҵĵصԺһ̴ҵҰԺʧһССĲҲӴ˲ٳ֡ӳ껪˵ҵġĬʾԡ˵ûиģС ϴѧʱʦνԼõĶ˺࿴һֱǵҾ仰Ŭһϲ磬ȴСİϲ˺ˣ˱硣 ˵ҰԼ߰㣬иչң˵ٲ޾ûҪˣǿҰһ˵ðҽܸ˰ɣҪڠػԸҡʵʱҲ26꣬30˵ǻ껪 һμ·1812ưɣҺ͵һžͿڰ̨ĽģһںƾơΪ˽ܣǵһμ棬ʵǶڶԷ̾ᡣкܶΣֹ ֹǽǸˣһСһ𡣵˵ЩҲںЩమˡ һθеһϬĬҸ룬һһӰҲҪҲһҰȻҿʼСؾӪݰ顣ϲ̨ĹĻһݳĹÿؼҡҽǸҰˡϣҵİԸƽ˿ڡһԭǺúõġҲ˵ĻһжᷢͽһʱˡҲҪһνŵ֣Ҵûమ˵ˣû˰ҪʲôֻΪӣһļҡ ˵뷨Ժ󣬽ľʧˡȥϰĵطܶҸҵ绰˵ҴˣҲҪȢңֻҪһڵ绰Ĭ벻׿Ϊʲô»ÿ˼㱣ϻؼǺ˼룬Ѹٵȥҵ1812ȥȾƣҺͿĵһμĵطԻڶߣһȴѾı䡣Һ˺ܶơҿһͷǹھƹˤһͷ­ҽ֪ΪʲôΪʲôһͷһ֪ͷǰŮǷҲй˵İ顣˵ϰӻҽԺͷǣǰһǳƯŮֻϴ20ꡣʥڵʱ򣬿̫裬ˤˣýճ˵һˣǰӳġ˵Ҳϲأҹҹϸð˵ôסһҪ˵Ůǰûй̹ĵİһһغȾơʱͿһҵǰĳסңͣ˵ԲԲȵҵϺҵһָе¶ȣůҿ˵ҲûҿԲҪҪ֣ʲôҪֻҪ뿪ҡ˵ĿԡǰڲӵʱˤϹ׵Ȼںˣʱпܵ÷̱ҪΪܿࡣ˵ҶҪһƶٰˡ˵ɵѾͷôܲأûһŻʲô˼ ʧõİҾöĿʵ㲻ʲôҸһңֻҪҲĶҺܺãƺҲй۵İϧΪӿԾһֱȥ˵ѾҪҪҺͿһ𡣶ңǱ˴మ ֪ǲҿЦһº󣬿ʧˡһһʲôԣȻͻȻʧ١ҵڼԲȵĵ绰ܾԺҿҪȥʱ򣬿Ĵشص绰˵ܸһңûԼķȢҡ 㾡һ׷ӡ˵ԼķˣˣȴԸٻߡ˺ܶ࣬ЩҲ˼ңȻôݡҺȻҸģһһ꣬һֱΪ˽Է˽Լһһֱ˰һжҪˡ˿̣Ҳŷȫ֪ʲôҪʲôҸеÿһεеĴСҸˣˡ·ϵʱһüսײкüΣһ㱿ڸңһҿˡ ͬ½飬ȥףڽ﷭ǵĻɴգﱯޱȡи߹˵ףôĲҿ¥Ѿվ˰СʱˣܽӡһΪڵءҸ˲֪ҺͿ֮Щ¡վ¥³壬ֻ¥һص̵١ȷſȻǰҵģֻҪ۷ʲôҶԭι£Ѿûгλİˡǰҵģӹɡڶ뿪ҵԭţ١ĳˡһֱʹȴұŮҲӡŮˣʮŮ˷ȻһֱԴڽϿĵһ۾϶ʹ˿̵찲ŵԵ֣ǣ뿪ңʼ׷һƺߵġ˵һŮƭҡһȥҲۣ벻ԲŸҡⷬʱҾԼǻȻΪôһݡΪûһɱҲôΪһԼ˶ĥԼ֪뿪ҵԭһ˿һѹģҲΪԼ۶ġǣֻص̨ȻûԲǸഺٵΣ˵Ļңû޷ȻʧЦ˵Ҳ˵Ļ˵޴ĻѲˣҲʹ˭û˭ûʲô˵ġҽ˿ĵĵһλЩ£Ĵû˵ҲӲǰڲӣƶǳͷءôŬӪҲһֱûдΪ˸ıˣȢ˲ϲųŮλûдתİڼŭǣˡƺ׷ֻһమ˺úӪͶһ൱ˣΪѾˣԲǡ˵ԲңʶЦЦ˵һжȥˡοԹ˭עġ18ʱע˵ġѡ񰮾ѡѡ һ˳СDJĹ ˵ҵ͸ž͸ľ ˵ԽԽ˵ǣһҹŮô ڱʼָָ㣬˵һ30Ů˻һ⡣ ҲΪ ֪һ죬һȥû˻˵18꣬иԳҵ˵㽫ע˾塣˵ôܣҲƯҲ̰ҲҪ̫࣬һֻ밮һΣֻҪһҵɷȻĺӡΪϴ´ӡҪ鵽ϡ ˵пֵͯ꣬˵ʲôδÿһ춼ڱ䣬ûгõĿѣȻҲûгõҸ⻰ʱҸоԼﵽ⿪ʼ䡣ô꣬һֱͼһԤԣȴͽ޹ܶˣҲҰңоǱ˴మȴΪԵ޷ݶòֿǶ˵ǺùȻһ23ʱҾ˵һʧܡҵĳӽǷֵʱҲĴ졣һؼǵãڽߵĲ԰ǶҿԷ۾ҵ۾ĴѲҿѿˣƵҶ¿ֵط賤кܶƯӵڽǡҶһֱվˮУϺõ̲衣ʶӽһǸĻǲǾһоͿѵĿʼأҺܺ¡ӽһڵСжѧϤҵļһϤСҪõѵС˵̨DJһҹֽĿӴˣ罻 Ҿ޶޸ĳƼһеĴƮһҰμҡеϱ߰ᵽߣٴӱ߰ᵽȻ󶫱ߡҺ޼Ưûоͷûϣӡÿʮϰ࣬ʮ°ࡣһԽеҹһܾµױƯ·峿ʱһȥưһʱ°ͻؼһ̨ԣȴѾ㹻ҹ˾ʱεÿ׼ʱ賿һȻڸBBS֮εддͣͣߡҺϸӣۻһȦʱڽĿ٩٩̸ʵ˼ȴ׾ڱǲ֪ĴǡرԼ뷨ʶ˲࣬һҰ˵ǹ»Ұֻҹûʱҽڤ˵ŮӲӦȡǵ֣ЦͣΪҲֻҹǴӲʶԷǸʲôģֻϲض˵˵ҵ˵ϲԼԼеҹĴɢ˵ھİҲ·˵ϣһӣ泯󺣣ůǰ˵ô˼άҡԴǵߵҲӲǷѡϲ໥ΣʹϡҽҰӲڤѾͷǵĳƺҵģֻҹһӲĮˣӲڰǸҰ˴ӲΪʲôֻǶ˵ҲһȱŮӣۡҶҰ˵ֻΪһŴ洢ҵĵصԺһ̴ҵҰԺʧһССĲҲӴ˲ٳ֡ӳ껪˵ҵġĬʾԡ˵ûиģС ϴѧʱʦνԼõĶ˺࿴һֱǵҾ仰Ŭһϲ磬ȴСİϲ˺ˣ˱硣 ˵ҰԼ߰㣬иչң˵ٲ޾ûҪˣǿҰһ˵ðҽܸ˰ɣҪڠػԸҡʵʱҲ26꣬30˵ǻ껪 һμ·1812ưɣҺ͵һžͿڰ̨ĽģһںƾơΪ˽ܣǵһμ棬ʵǶڶԷ̾ᡣкܶΣֹ ֹǽǸˣһСһ𡣵˵ЩҲںЩమˡ һθеһϬĬҸ룬һһӰҲҪҲһҰȻҿʼСؾӪݰ顣ϲ̨ĹĻһݳĹÿؼҡҽǸҰˡϣҵİԸƽ˿ڡһԭǺúõġҲ˵ĻһжᷢͽһʱˡҲҪһνŵ֣Ҵûమ˵ˣû˰ҪʲôֻΪӣһļҡ ˵뷨Ժ󣬽ľʧˡȥϰĵطܶҸҵ绰˵ҴˣҲҪȢңֻҪһڵ绰Ĭ벻׿Ϊʲô»ÿ˼㱣ϻؼǺ˼룬Ѹٵȥҵ1812ȥȾƣҺͿĵһμĵطԻڶߣһȴѾı䡣Һ˺ܶơҿһͷǹھƹˤһͷ­ҽ֪ΪʲôΪʲôһͷһ֪ͷǰŮǷҲй˵İ顣˵ϰӻҽԺͷǣǰһǳƯŮֻϴ20ꡣʥڵʱ򣬿̫裬ˤˣýճ˵һˣǰӳġ˵Ҳϲأҹҹϸð˵ôסһҪ˵Ůǰûй̹ĵİһһغȾơʱͿһҵǰĳסңͣ˵ԲԲȵҵϺҵһָе¶ȣůҿ˵ҲûҿԲҪҪ֣ʲôҪֻҪ뿪ҡ˵ĿԡǰڲӵʱˤϹ׵Ȼںˣʱпܵ÷̱ҪΪܿࡣ˵ҶҪһƶٰˡ˵ɵѾͷôܲأûһŻʲô˼ ʧõİҾöĿʵ㲻ʲôҸһңֻҪҲĶҺܺãƺҲй۵İϧΪӿԾһֱȥ˵ѾҪҪҺͿһ𡣶ңǱ˴మ ֪ǲҿЦһº󣬿ʧˡһһʲôԣȻͻȻʧ١ҵڼԲȵĵ绰ܾԺҿҪȥʱ򣬿Ĵشص绰˵ܸһңûԼķȢҡ 㾡һ׷ӡ˵ԼķˣˣȴԸٻߡ˺ܶ࣬ЩҲ˼ңȻôݡҺȻҸģһһ꣬һֱΪ˽Է˽Լһһֱ˰һжҪˡ˿̣Ҳŷȫ֪ʲôҪʲôҸеÿһεеĴСҸˣˡ·ϵʱһüսײкüΣһ㱿ڸңһҿˡ ͬ½飬ȥףڽ﷭ǵĻɴգﱯޱȡи߹˵ףôĲҿ¥Ѿվ˰СʱˣܽӡһΪڵءҸ˲֪ҺͿ֮Щ¡վ¥³壬ֻ¥һص̵١ȷſȻǰҵģֻҪ۷ʲôҶԭι£Ѿûгλİˡǰҵģӹɡڶ뿪ҵԭţ١ĳˡһֱʹȴұŮҲӡŮˣʮŮ˷ȻһֱԴڽϿĵһ۾϶ʹ˿̵찲ŵԵ֣ǣ뿪ңʼ׷һƺߵġ˵һŮƭҡһȥҲۣ벻ԲŸҡⷬʱҾԼǻȻΪôһݡΪûһɱҲôΪһԼ˶ĥԼ֪뿪ҵԭһ˿һѹģҲΪԼ۶ġǣֻص̨ȻûԲǸഺٵΣ˵Ļңû޷ȻʧЦ˵Ҳ˵Ļ˵޴ĻѲˣҲʹ˭û˭ûʲô˵ġҽ˿ĵĵһλЩ£Ĵû˵ҲӲǰڲӣƶǳͷءôŬӪҲһֱûдΪ˸ıˣȢ˲ϲųŮλûдתİڼŭǣˡƺ׷ֻһమ˺úӪͶһ൱ˣΪѾˣԲǡ˵ԲңʶЦЦ˵һжȥˡοԹ˭עġ18ʱע˵ġѡ񰮾ѡѡ һ˳СDJĹ ˵ҵ͸ž͸ľ ˵ԽԽ˵ǣһҹŮô ڱʼָָ㣬˵һ30Ů˻һ⡣ ҲΪ ֪һ죬һȥû˻˵";

        for (int i = 0; i < 7; i++) {// =ԭ1282,185,856 4,347,520ֽ
            testString += testString;
        }

        long b2 = System.currentTimeMillis();// (b2 - b1)Ϊװشʵʱ
        Reader r = new StringReader(testString);
        XTokenizer ts = (XTokenizer) analyzer.tokenStream("", r);

        Token t;
        while ((t = ts.next()) != null) {
             System.out.println(t);
        }

        long b3 = System.currentTimeMillis();

        System.out.println("");
        System.out.println(":::´С: " + testString.length() + " " + testString.getBytes().length + "ֽ");
        System.out.println(":::ʵװغʱ: " + (b1 - b0) + " ms");
        System.out.println(":::д+ӡʱ: " + (b3 - b2) + " ms");

    }

    private static void afterLoadingDictionary(XAnalyzer analyzer) throws IOException {
        analyzer.tokenStream("", new StringReader("")).next();
    }

}
